<?php
// v0.10
// see class_c64reader.php for more info

class ArkImage
{
	var $imagefile = "";
	var $num_entries = 0;
	var $error = "";
	var $entries = array();

	function ArkImage(&$image)
	{
		$this->imagefile = $image;
		$u = unpack("centries", substr($image, 0, 1));
    $this->num_entries     = $u["entries"];   
    $block_offset = ceil((1 + 29 * $this->num_entries)/254) * 254;      
    $offset = 0;     
		for ($i = 0; $i < $this->num_entries * 29 ; $i += 29)
		{
  	 $entry = array();
     $entry["filename"]    = substr($image, $i+3, 16);
     $entry["start"]       = $block_offset + $offset; 
     $u                    = unpack("Cfiletype/Clsu", substr($image, $i+1, 2));
     $entry["filetype"]    = $u["filetype"];
     $LSU                  = $u["lsu"];
     $u                    = unpack("vlength", substr($image, $i+28, 2));
     $entry["blocksize"]   = ceil($u["length"]);
     $entry["filesize"]    = $entry["blocksize"] * 254 - 256 + $LSU;
		 $entry["filedata"]    = substr($image, $entry["start"], $entry["filesize"]);
     $entry["end"]         = $entry["start"] + $entry['filesize'];
     $entry["error"]       = ($entry["end"] > strlen($image)) ? 'error' : '';
     $this->error          = $entry["error"] ? 'Error' : '';
     $this->entries[]      = $entry;
     $offset               += $entry["blocksize"] * 254;
    }    
	}
}
?>
