<?php
// v0.10
// see class_c64reader.php for more info

class C64Image
{
	var $imagefile = "";
	var $num_entries = 0;
	var $error = "";
	var $signature = "";
	var $entries = array();

	function C64Image(&$image, $filename)
	{
		$this->imagefile = $image;   
    if ( ($image[0]=="\x38") AND ($image[1]=="\xCD") )
    { 
      # not sure about DOS BINARY FILES, see spec-file
      $entry = array();      
      $u = unpack("Clength", substr($image, 3, 1)); 
      $entry["filename"]       = substr($image, 4, $u["length"]);     
      $entry["filetype"]       = $image[2]=="\x60" ? 'PRG' : 'PRG';
      $image = rtrim($image, "\x00");
      $entry["start"]          = 36;
      $entry["end"]            = strlen($image);
      $entry["filesize"]       = $entry["end"] - $entry["start"];
      $entry["filesizeblocks"] = ceil($entry["filesize"] / 254);
      $entry["filedata"]       = substr($image, $entry["start"], $entry["filesize"]);
      $entry['error']          = ""; // cant say anything about that 
      $this->entries[]         = $entry;          
    }
    elseif( ($image[0]=="\x01") AND ($image[1]=="\x08") )
    { 
      $entry = array();      
		  $entry['filename']       = $filename;
		  $entry['filetype']       = 'PRG';
  		$entry['filesize']       = strlen($image);
	   	$entry['filesizeblocks'] = ceil($entry['filesize'] / 254);
  	 	$entry['start']          = 0;
	 	  $entry['end']            = $entry['filesize'];
		  $entry['filedata']       = $image;
		  $entry['error']          = '';
      $this->entries[]         = $entry;          
    }
    elseif( substr($image, 0, 7)=='C64File')
    {
      $entry = array();      
  		$entry['filesize']       = strlen($image) - 26;
	 	  $entry['filesizeblocks'] = ceil($file_entry['filesize'] / 254);
	   	$entry['start']          = 26;
  		$entry['end']            = $entry['filesize'] + 26;
		  $entry['filedata']       = substr($image, 26);
		  $entry['error']          = '';
      $this->entries[]         = $entry;
    }
    elseif( substr($image, 0, 8)=='C64Image')
    {
      # PC64 saved-session file.
    }
    else
    {
      # Unknown .c64 file, maybe a frozen image ... who knows & who cares ?!
    }
  }
}
?>
