<?php
ob_start();
require_once('config.php');
set_time_limit(0);  // no time limit to finish script!

echo $html_begin;
echo "<fieldset style='width:600px;'><legend><b>Compare</b></legend>";
echo "<i>-check if there are new/redundant files in a new collection!</i><br><br>";

$dir_list = scandir(ARCHIVE_PATH);    
ignorecasesort($dir_list); 
    
echo "<form name='form_add_pack' action='compare_module.php' method='post'>";
echo "<select name='sel_pack'>";
echo "<option disabled value=''>Chose collection</option>";
for ($i=0;$i<sizeOf($dir_list);$i++)
 {
  $dir_entry = $dir_list[$i];
  if ($dir_entry != "." && $dir_entry != "..") 
  {
    if (is_dir(ARCHIVE_PATH.$dir_entry)) 
    {
      echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
    }
  }  
 }
echo "</select>";
echo "<input type='submit' name='compare_btn' value='Compare'><br><input type=checkbox name=delete_redudant> Delete redundant files!!!";
echo "<input type=checkbox name=chk_show_info checked> Show detailed info";
echo "<br></form></fieldset>";

function traversedir($path, $dir) 
  {
    global $DB;
    global $redundant;
    global $unique;
    global $unformated;
    global $total_entries;
    global $unique_entries;
    global $delete_chk;
    global $Lext;
    
    $k = 0;
    $dir_list = scandir($path.$dir);
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($path.$dir.$dir_entry)) 
        {
          traversedir($path, $dir.$dir_entry.'/');
        }
        else if (is_file($path.$dir.$dir_entry)) 
        {
         $file_extension = strtolower(substr(strrchr($dir_entry,"."),1));
         if (!empty($Lext[$file_extension])) 
         {
          $total_entries += 1;
          $filename = $path.$dir.$dir_entry;         
          $fp = fopen($filename,'r');
          $file_size = filesize($filename);  
          if ( ($file_size<20480000) && ($file_size>0) )
          {
            $raw_data = fread($fp, $file_size);
            fclose($fp);
            $md5hash = md5($raw_data);
            
            // 1) Check if image already is in database. If not then 
            // 2) check if we have a simple datatype (prg, p00) AND if the data is already in database
            // if still false then we have a new archive 
            $SQLcompare = $DB->get_hyper_media_2($md5hash, false);
            if ( (mysql_num_rows($SQLcompare)==0) AND ($file_extension<>'d64') ) {
              $SQLcompare = $DB->get_hyper_media_md5($md5hash, false);
            }
                           
            if ( (mysql_num_rows($SQLcompare)==0) OR (is_unformated_d64($md5hash)) ){
              $view_dir = "";
              if (is_unformated_d64($md5hash)) {$view_dir = 'UNF';$unformated++;} 
              else {
                $view_dir = "<a target=_BLANK href='view_directory.php?filename=". base64_encode($filename)."'>dir</a>";
                $unique_entries++;
                if (!empty($_REQUEST['chk_show_info']))
                {
                  $c64_object = new c64file($filename, $raw_data, false);
                  $unique .= "<tr><td>".$dir.$dir_entry."</td>";
                  $unique .= "<td align='center'>". (($c64_object->num_errors>0) ? "<font color='red'>". $c64_object->num_errors ."</font>" : "&nbsp;") ."</td>";
                  $unique .= "<td align='center'>$view_dir</td></tr>";
                }                
              }    
            }
            else{
              $row = mysql_fetch_array($SQLcompare, MYSQL_ASSOC);
              $redundant .= "<tr><td>".$dir.$dir_entry."</td><td align=center><a target=_BLANK href='view_directory.php?filename=". base64_encode($filename)."'>dir</a></td><td>".$row['source']. "</td><td style='text-align:right;'>". mysql_num_rows($SQLcompare) ."</td></tr>";
              
              if ($delete_chk)
              {                
                @chmod($filename,0777);unlink($filename);
                echo "<BR>DELETED FILE: ".$filename;
                ob_flush();flush();
              }          
            }      
          }
          else
          {
            fclose($fp); // file_size==0, close file  
          }                 
         }
        }
        else
        {
          echo "<br>!Unknown! : ".$dir.$dir_list[$i]."<br>";
        }
      }  
    } 
  }

$pack_name   = (!empty($_REQUEST['sel_pack'])) ? $_REQUEST['sel_pack'] : null;
$compare_btn = (!empty($_REQUEST['compare_btn'])) ? $_REQUEST['compare_btn'] : null;
$delete_chk  = (!empty($_REQUEST['delete_redudant'])) ? $_REQUEST['delete_redudant'] : null;


if (($compare_btn)  AND ($pack_name))
{ 
    echo "<h3>$pack_name</h3>";ob_flush();flush();
    $total_entries    = 0;
    $unique_entries = 0;
    $unformated = 0;
    $unique    = "<table border=1><th>Filename</th><th>Errors</th><th>Dir</th>";
    $redundant = "<table border=1><th>Filename</th><th>Dir</th><th>Already located here</th><th>Count</th>";
    $pack_name .= "/";  
    $path = ARCHIVE_PATH . $pack_name;   
    if (is_dir($path))
    {
      traversedir($path,'');
      $redundant .= "</table>";
      echo "<br><b>Total unique files:".$unique_entries." out of ".$total_entries."</b><br>";
      $redundant_entries = $total_entries - $unique_entries - $unformated;
      echo "Redundant files:".$redundant_entries."<br>";
      echo "Unformated media:".$unformated."<br>";
      echo "<h3 style='display:inline;'>Redundant files:</h3>".$redundant."</table><hr><h3 style='display:inline;'>Unique files:</h3>".$unique."</table><hr>";
    }
    else
    {
      echo "<h3>not a valid dir $pack_name</h3>";  
    }
 }   
   
  echo "</fieldset>";

# }
    echo $html_end;
    ob_end_flush();
?>
