<?php
require_once('database.php');
require_once('functions.php');
require_once("ReaderClass/class_c64reader.php");
// ---------------------------------------------------------------------------
DEFINE('ARCHIVE_PATH', "c:/C64files/");
DEFINE('ARCHIVE_IMAGES', "images/");
DEFINE('ARCHIVE_VIRUS', "virus/");
DEFINE('ARCHIVE_TMP', "tmp/");
DEFINE('SHOW_DEBUG', 0);

// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  EDIT THIS DIRECTORY!

// check if internal_dir exists!
if (!is_dir(ARCHIVE_PATH)){echo"<h3><i>Warning: path to c64 files does not exist!</i> " . ARCHIVE_PATH . "</h3>";}
if (!is_dir(ARCHIVE_IMAGES)){mkdir(ARCHIVE_IMAGES);}
if (!is_dir(ARCHIVE_VIRUS)){mkdir(ARCHIVE_VIRUS);}
if (!is_dir(ARCHIVE_TMP)){mkdir(ARCHIVE_TMP);}
// ---------------------------------------------------------------------------

// create an DB-class instance
  $DB = new DB();

// --------------------------------------------------------------------------- 
  $missing_list       = "missing.txt";
  $tdd                = 'ftp://ftp.scs-trc.net/pub/c64/WANTED_DEMOS.TXT';
  $mags               = 'ftp://ftp.scs-trc.net/pub/c64/WANTED_MAGS.TXT';
  $c64heaven          = 'http://www.c64heaven.com/wanted/missing.txt';
  if (!is_file($missing_list)){$fh=fopen($missing_list, "w");fclose($fh);} 
// ---------------------------------------------------------------------------

// accepted c64 formats 
$Lext = array_flip(array("-", "d64", "d71", "d81", "t64", "lnx", "p00", "prg", "g64", "nib", "tap", "crt", "z64", "rom", "bin", "l64", "n64", "ark", "f64", "lbr", "spy", "x64", "cvt", "sda", "sfx" ));

// skip extentions
$Lskip_ext = array_flip(array("-", "zip", "rar", "7z", "gz", "lha" ));

$Lvirus_signatures = array();
if (is_dir(ARCHIVE_VIRUS)){
  $virus_dir = scandir(ARCHIVE_VIRUS);
  foreach ($virus_dir as $signature){
    $virus_filename = ARCHIVE_VIRUS . $signature;
    if (is_file($virus_filename)) {
      $fh = fopen($virus_filename, 'rb');$virus_data = fread($fh, filesize($virus_filename));fclose($fh);    
      $Lvirus_signatures[$signature] = $virus_data;
    }
  }
}

$Lbasic_num = array(chr(143),chr(158),chr(151),chr(139),chr(194),chr(167),chr(153),chr(137),chr(156),chr(178),chr(164),chr(170),chr(177),chr(179),chr(134),chr(199),chr(141),chr(129),chr(135),chr(195),chr(202),chr(130),chr(142),chr(131),chr(169),chr(181),chr(187),chr(153),chr(161),chr(175),chr(171),chr(172),chr(173),chr(176),chr(163),chr(166),chr(23),chr(162),chr(20),chr(128),chr(19),chr(18),chr(145),chr(15),chr(5),chr(198),chr(186),chr(190),chr(191),chr(192),chr(133),chr(189),chr(160),chr(1),chr(136),chr(138),chr(147),chr(140) ,chr(155),chr(144),chr(196),chr(200),chr(201),chr(174),chr(132),chr(146),chr(148),chr(149),chr(150),chr(152),chr(154),chr(157),chr(159),chr(165),chr(168),chr(197) ); 
$Lbasic_val = array('REM'   ,'SYS'   ,'POKE'  ,'IF'    ,'PEEK'  ,'THEN'  ,'PRINT' ,'GOTO'  ,'CLR'   ,'='     ,'TO'    ,'+'     ,'>'     ,'<'     ,'DIM'   ,'CHR$'  ,'GOSUB' ,'FOR'   ,'READ'  ,'LEN'   ,'MID'   ,'NEXT'  ,'RETURN','DATA'  ,'STEP'  ,'INT'   ,'RND'   ,'AND'   ,'GET'   ,'AND'   ,'-'     ,'*'     ,'/'     ,'OR'    ,'(TAB' , '(SPC'  ,''     ,'NEW'   ,' '    ,'END'   ,' '    ,' '    ,'ON'    ,''     ,''    ,'ASC'   ,'SQR'   ,'SIN'   ,'COS'   ,'TAN'   ,'INPUT' ,'EXP'   ,'CLOSE' ,' '   ,'LET'   ,'RUN'   ,'LOAD'  ,'RESTORE','LIST'  ,'STOP'  ,'STR$'  ,'LEFT$' ,'RIGHT$','^'     ,'INPUT#','WAIT'  ,'SAVE'  ,'VERIFY','DEF'   ,'PRINT#','CONT'  ,'CMD'   ,'OPEN'  ,'FN',   'NOT'    ,'VAL'   );  

$Nvisible_sysline = 60; # Length of visible sysline


// ---------------------------------------------------------------------------


$html_begin = "
           <!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>
           <html>
           <head>
           <meta http-equiv='content-type' content='text/html; charset=windows-1250'>
           <meta name='generator' content='PSPad editor, www.pspad.com'>
           <title>PreserveC64DB by m4z</title>
           <link rel='stylesheet' type='text/css' href='styles.css'>
           <script language='JavaScript' src='functions.js'></script>
           </head>
           <body>
           <h2 style='display:inline;'>PreserveC64DB v1.1</h2><br>
           <a class='menu' href='search.php'>[Search]</a> |
           <a class='menu' href='matchc64.php'>[Matcher]</a> |
           <a class='menu' href='import_module.php'>[Import]</a> | 
           <a class='menu' href='compare_module.php'>[Compare]</a> |
           <a class='menu' href='uniquedata_module.php'>[Unique]</a> |
           <a class='menu' href='publishers.php'>[Publishers]</a> | 
           <a class='menu' href='collections.php'>[Collections]</a> | 
           <a class='menu' href='statistics.php'>[Statistics]</a> | 
           <a class='menu' href='missing.php'>[Missing]</a> |
           <a class='menu' href='help.php'>[Help]</a> | 
           <hr>";

$html_end = "</body></html>";
            

?>
