<?php
require_once('config.php');
set_time_limit(0);  // no time limit to finish script!

# Send file to browser if requested downloaded
if(!empty($_REQUEST['download_hyper_media'])){echo $DB->download_media($_REQUEST['download_hyper_media'], null, ARCHIVE_PATH);}

// Get form inputs
$data_md5 = (!empty($_REQUEST['data_md5'])) ? $_REQUEST['data_md5'] : null;  

if (!empty($_REQUEST['upload']))
{
  $file_extension = strtolower(substr(strrchr($_FILES['upload_file_name']['name'],"."),1));
  if ($file_extension)
  {
    $preview_id = $DB->add_preview($file_extension, $_REQUEST['release_id'], $_REQUEST['select_prev_type']);    

    if(!move_uploaded_file($_FILES['upload_file_name']['tmp_name'], ARCHIVE_IMAGES.$preview_id.".".$file_extension)) {
      echo "There was an error uploading the file!";
    }
    else{
      echo "<br><b>Preview was successfully uploaded</b>";    
    }   
  }
  else{
      echo "<br><b>No file found!</b>";      
  }
  
  # echo "<form name=form action='release.php' method=POST><br><input type=submit value='Ok'></form>";
  # exit;
}

if ( (!empty($_REQUEST['rm_pub'])) && ($data_md5) && (!empty($_REQUEST['Lpub_id'])) ){
# Remove these publisher(s) from this release
  echo "DELETE PUBLISHER" . NL;
  for ($i=0;$i<sizeOf($_REQUEST['Lpub_id']);$i++){
    $DB->remove_publisher_from_release($_REQUEST['Lpub_id'][$i], $data_md5);
  }
}

if ( (!empty($_REQUEST['add_pub'])) && (!empty($_REQUEST['pub_id'])) && ($data_md5) )  {
# Add this publisher to this release
  echo "ADD PUBLISHER" . NL;
  $DB->set_publisher_to_release($_REQUEST['add_pub_id'], $data_md5 );
}


if ( (!empty($_REQUEST['add_data_pub'])) && (!empty($_REQUEST['pub_id'])) && ($data_md5) && (!empty($_REQUEST['rel_type_id'])) )  {
# Add this publisher to this data as release_type.
  echo "ADD DATA PUBLISHER & TYPE" . NL;
  $DB->set_data_to_publisher($data_md5, $_REQUEST['pub_id'], $_REQUEST['rel_type_id']);
}



if ( (!empty($_REQUEST['genre_id'])) && ($data_md5) ){
  echo "CHANGE GENRE" . NL;
  $DB->set_genre_to_release($_REQUEST['genre_id'], $data_md5);
}

if ( ((!empty($_REQUEST['chg_rel_info'])) && (!empty($_REQUEST['rel_id']))) || ((!empty($_REQUEST['genre_id'])) && (!empty($_REQUEST['rel_id']))) ) {
  echo "CHANGE REL INFO" . NL;
  $DB->set_release_info($_REQUEST['rel_id'], $_REQUEST['rel_name'], $_REQUEST['rel_subject'],
                        $_REQUEST['rel_description'], $_REQUEST['rel_coverage'],
                        $_REQUEST['rel_date'], $_REQUEST['rel_creator'],
                        $_REQUEST['rel_identifier'], $_REQUEST['rel_language'],
                        $_REQUEST['rel_rights'], $_REQUEST['rel_contributer'],
                        $_REQUEST['rel_audiance'], $_REQUEST['rel_rightsholder']);	
}


if ( (!empty($_REQUEST['rm_prev'])) && (!empty($_REQUEST['Lrm_prev_id'])) ){
  echo "REMOVE PREV" . NL;
  for ($i=0;$i<sizeOf($_REQUEST['Lrm_prev_id']);$i++){
    $DB->remove_preview_from_release($_REQUEST['Lrm_prev_id'][$i]);
  }
}

if ( (!empty($_REQUEST['chg_prev'])) && (!empty($_REQUEST['Lprev_desc'])) ){
  echo "CHANGE PREVIEW INFO" . NL;
  for ($i=0;$i<sizeOf($_REQUEST['Lprev_id']);$i++){
    $DB->set_preview_description($_REQUEST['Lprev_id'][$i], $_REQUEST['Lprev_desc'][$i])  ;
  }  
}

if ( (!empty($_REQUEST['add_rel'])) && (!empty($_REQUEST['rel_name'])) && ($data_md5) ){
  echo "ADD NEW RELEASE" . NL;
  $DB->add_release($_REQUEST['rel_name'], $data_md5);
}

if ( (!empty($_REQUEST['del_rel'])) && (!empty($_REQUEST['rel_id'])) ){
  echo "DELETE RELEASE" . NL;
  $DB->del_release($_REQUEST['rel_id']);
}


if ( (!empty($_REQUEST['add_dep'])) && (!empty($_REQUEST['dep_md5'])) && (!empty($_REQUEST['rel_id'])) ){
  echo "ADD DEPENDENCY" . NL;
  if (!$DB->add_dependency($_REQUEST['rel_id'], $_REQUEST['dep_md5'])){
    echo NL . "<i>FAILED: file is already dependant of another release!!</i>";
  }
}


if ( (!empty($_REQUEST['rm_dep'])) && (!empty($_REQUEST['rel_id'])) && (!empty($_REQUEST['Lrm_dep_id'])) ){
  echo "REMOVE DEPENDENCY" . NL;
  for ($i=0;$i<sizeOf($_REQUEST['Lrm_dep_id']);$i++){
    $DB->remove_dependencies($_REQUEST['Lrm_dep_id'][$i], $_REQUEST['rel_id'])  ;
  }
}


if ( (!empty($_REQUEST['status_id'])) && ($data_md5) ){
  echo "CHANGE STATUS" . NL;
  $DB->update_data_status($data_md5, $_REQUEST['status_id']);
}


if ( (!empty($_REQUEST['os_id'])) && ($data_md5) ){
  echo "CHANGE OPERATIVE SYSTEM" . NL;
  $DB->update_data_OS($data_md5, $_REQUEST['os_id']);
}


if ( (!empty($_REQUEST['rm_mod'])) && (!empty($_REQUEST['Lre_mod_id'])) && ($data_md5) ){
  echo "REMOVE MODIFIER" . NL;
  for ($i=0;$i<sizeOf($_REQUEST['Lre_mod_id']);$i++){
    $DB->remove_modifier($data_md5, $_REQUEST['Lre_mod_id'][$i])  ;
  }
}
 
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=windows-1250">
    <meta name="generator" content="PSPad editor, www.pspad.com">
    <link rel='stylesheet' type='text/css' href='styles.css'>
    <script language='JavaScript' src='functions.js'></script>
    <title>Catalog Publication</title>
  </head>
  <body>
<fieldset style='width:600px;'><legend><b>Catalog Publication</b></legend>

<?php

$SQLresult = $DB->get_release_info($data_md5);
$release = mysql_fetch_array($SQLresult); 
$release_id = $release['id'];
# Release descriptions
echo "<fieldset style='width:600px;'><legend><b>Publication</b></legend>";
echo "<form name='form_release' action='release.php' method='post' enctype='multipart/form-data'>";

# Check if the data_md5 is connected to an release
if ($release_id){
echo "<table>";
echo "<tr><td>Title</td><td><input size=40 name=rel_name type=text value='".$release['name']."'></td><td><input type=submit name=chg_rel_info value='update'><input type=submit name=del_rel value='delete'></td></tr>";
echo "<tr><td>Subject</td><td><input size=40 name=rel_subject type=text value='".$release['subject']."'></td><td></td></tr>";
echo "<tr><td>Description</td><td><input size=40 name=rel_description type=text value='".$release['description']."'></td><td></td></tr>";
echo "<tr><td>Audiance</td><td><input size=40 name=rel_audiance type=text value='".$release['audiance']."'></td><td></td></tr>";
echo "<tr><td>Coverage</td><td><input size=40 name=rel_coverage type=text value='".$release['coverage']."'></td><td></td></tr>";
echo "<tr><td>Date</td><td><input name=rel_date type=text value='".$release['date']."'></td><td></td></tr>";
echo "<tr><td>Creator</td><td><input size=40 name=rel_creator type=text value='".$release['creator']."'></td><td></td></tr>";
echo "<tr><td>Identifier</td><td><input size=40 name=rel_identifier type=text value='".$release['identifier']."'></td><td></td></tr>";
echo "<tr><td>Language</td><td><input size=20 name=rel_language type=text value='".$release['language']."'></td><td></td></tr>";
echo "<tr><td>Rights</td><td><input size=40 name=rel_rights type=text value='".$release['rights']."'></td><td></td></tr>";
echo "<tr><td>Rights Holder</td><td><input size=40 name=rel_rightsholder type=text value='".$release['rightsholder']."'></td><td></td></tr>";
echo "<tr><td>Contributer</td><td><input size=40 name=rel_contributer type=text value='".$release['contributer']."'></td><td></td></tr>";
echo "</table><input name=rel_id value='$release_id' type=hidden>";
echo NL . "<b>Preview: screenshots</b>" . NL;
$SQLpreviw = $DB->get_release_previews($release_id, 'image');
echo "<table>";
while ($preview = mysql_fetch_array($SQLpreviw)){ 
  echo "<tr><td><a href='".ARCHIVE_IMAGES.$preview['id'].".".$preview['extension']."' target=_BLANK ><img width=150 height=106 src='".ARCHIVE_IMAGES.$preview['id'].".".$preview['extension']."' title='".$preview['description']."'></a></td>";
  echo "<td>description:<br><input name=Lprev_desc[] type='text' value='".$preview['description']."'></td><td><input name=Lprev_id[] type=hidden value=".$preview['id']." ><input name=chg_prev type=submit value=update><br><input name=Lrm_prev_id[] type=checkbox value=".$preview['id']."><input name=rm_prev type=submit value=delete></td></tr>";
}
echo "</table>";
echo NL . "<b>Preview: videos</b>" . NL;
$SQLpreviw = $DB->get_release_previews($release_id, 'video');
echo "<table>";
while ($preview = mysql_fetch_array($SQLpreviw)){ 
  echo "<tr><td><a href='".ARCHIVE_IMAGES.$preview['id'].".".$preview['extension']."' target=_BLANK >".$preview['description']."</a></td>";
  echo "<td>description:<br><input name=Lprev_desc[] type='text' value='".$preview['description']."'></td><td><input name=Lprev_id[] type=hidden value=".$preview['id']." ><input name=chg_prev type=submit value=update><br><input name=Lrm_prev_id[] type=checkbox value=".$preview['id']."><input name=rm_prev type=submit value=delete></td></tr>";
}
echo "</table>";

$SQLpreviw_types = $DB->get_preview_types();
echo "<hr><b>Upload</b> preview of type: "; 
echo "<select name='select_prev_type'>";
while ($result = mysql_fetch_array($SQLpreviw_types)){ 
  echo "<option value=\"".$result['id']."\">".$result['type']."</option>";
}
echo "</select>, file location:";
echo "<input type='file' name='upload_file_name'>";
echo "<input type='submit' name='upload' value='Upload'>";
echo "<input type='hidden' name='release_id' value=".$release_id.">";
echo "</fieldset>";
} # $release exists
else {
echo "<table>";
echo "<tr><td>Title</td><td><input size='40' name='rel_name' type='text' ></td><td><input type='submit' name='add_rel' value='add'></td></tr>";
echo "</table>";
}

echo "<input name='data_md5' value=$data_md5 type='hidden'>";

$result = mysql_fetch_array($DB->get_release_info($data_md5));
# DATA descriptions
echo "<fieldset style='width:600px;'><legend><b>Data</b></legend>";
echo "<table>";

echo "<tr><td>Publisher(s)</td><td><a target='_BLANK' href='http://noname.c64.org/csdb/group/?id=".$release['publisher_id']."'>".$release['publisher_name']."</a></td><td><input type='checkbox' name=Lpub_id[] value=".$release['publisher_id']."><input name='rm_pub' type='submit' value='delete'></td></tr>";
$Ltemp[$release['publisher_id']] = 1;
while ($release = mysql_fetch_array($SQLresult)){
    if (!array_key_exists($release['publisher_id'], $Ltemp)){
      echo "<tr><td></td><td><a target='_BLANK' href='http://noname.c64.org/csdb/group/?id=".$release['publisher_id']."'>".$release['publisher_name']."</a></td><td><input type='checkbox' name=Lpub_id[] value=".$release['publisher_id']."><input name='rm_pub' type='submit' value='delete'></td></tr>";
      $Ltemp[$release['publisher_id']] = 1;
    }
}
echo "<tr><td></td><td><select name='add_pub_id'>";
$SQLpublishers = $DB->get_publishers();
while ($publisher = mysql_fetch_array($SQLpublishers)){
  $short   = $publisher['short']<>''        ? " (".$publisher['short'].")"        : " ";
  $country = $publisher['base_country']<>'' ? " [".$publisher['base_country']."]" : " ";
  echo "<option value=".$publisher['id'].">".$publisher['name'].$short.$country."</option>";
}
echo "</select>"; 
echo "<td><input name='add_pub' type='submit' value='add'></td></tr>";

$SQLmodifiers = $DB->get_modifiers($data_md5);
$modifier = mysql_fetch_array($SQLmodifiers);
echo "<tr><td>Provenance:</td><td><a target='_BLANK' href='http://noname.c64.org/csdb/group/?id=".$modifier['publisher_id']."'>" . $modifier['publisher_name']."</a>(".$modifier['release_type'].")</td><td style='width:100px;'><input type=checkbox name=Lre_mod_id[] value=".$modifier['publisher_id']."><input type=submit name=rm_mod value=delete></td></tr>";
while ($modifier = mysql_fetch_array($SQLmodifiers)){
  echo "<tr><td></td><td><a target='_BLANK' href='http://noname.c64.org/csdb/group/?id=".$modifier['publisher_id']."'>" . $modifier['publisher_name']."</a>(".$modifier['release_type'].")</td><td><input type=checkbox name=Lre_mod_id[] value=".$modifier['publisher_id']."><input type=submit name=rm_mod value=delete></td></tr>";
}
echo "</td></tr>";
echo "<tr><td></td><td><select name='pub_id'>";
$SQLpublishers = $DB->get_publishers();
while ($publisher = mysql_fetch_array($SQLpublishers)){
  $short   = $publisher['short']<>''        ? " (".$publisher['short'].")"        : " ";
  $country = $publisher['base_country']<>'' ? " [".$publisher['base_country']."]" : " ";
  echo "<option value=".$publisher['id'].">".$publisher['name'].$short.$country."</option>";
}
echo "</select><select name='rel_type_id'>";
$SQLrelease_types = $DB->get_release_types();
while ($release_type = mysql_fetch_array($SQLrelease_types)){
  echo "<option value=".$release_type['id'].">".$release_type['type']."</option>";
}
echo "</select><input name='add_data_pub' type='submit' value='add'></td></tr>";

echo "<tr><td>Sysline</td><td>".$result['sysline']."</td></tr>";
echo "<tr><td>Blocks</td><td>".ceil($result['bytes']/254)."</td></tr>";
echo "<tr><td>Operative System</td><td>".$result['operative_system']." ";
$SQLos = $DB->get_operative_systems();
echo "<select name=os_id onchange='submit()'>";
echo "<option value=''>Chose OS</option>";
while ($os = mysql_fetch_array($SQLos)){
  echo "<option value=".$os['id'].">".$os['name']."</option>";
}
echo "</select></td></tr>";

$SQLgenre = $DB->get_genre();
echo "<tr><td>Type</td><td>".$result['genre']." <select name='genre_id' onchange='submit()'>";
echo "<option value=''>Set type</option>";
while ($genre = mysql_fetch_array($SQLgenre)){
  echo "<option value=".$genre['id'].">".$genre['genre']."</option>";
}
echo "</select></td></tr>";


$SQLstatus = $DB->get_status();
echo "<tr><td>Status</td><td>".$result['status']." ";
echo "<select name='status_id' onchange='submit()'>";
echo "<option value=''>Chose status</option>";
while ($status = mysql_fetch_array($SQLstatus)){
  echo "<option value=".$status['id'].">".$status['name']."</option>";
}
echo "</select></td></tr>";
echo "<tr><td>ErrorTypes</td><td>".decbin($result['error_bits'])."</td></tr>";
$error_blocks = $result['error_bits']>0 ? str_replace('1','.',$result['error_bytes']) : " ";
echo "<tr><td>ErrorBlocks</td><td style='font-size:8px;'>".$error_blocks."</td></tr>";
echo "<tr><td>Comment</td><td><input style='text-align:right;' type='text' name='i_comment' size='25' value='".$result['comment']."'>
      <input type='button' name='upd_comment' value='save' onclick=\"javascript: SaveComment(i_comment.value, ".$result['data_id'].")\"></td></tr>";
echo "</table>";

# Directory Entry identifiers
$SQLsearch = $DB->get_media_entries($data_md5);
echo "<fieldset style='width:570px;'><legend><b>Different Directory Entries</b></legend>";
echo "<table><th>Filename</th><th>Blocks</th><th>Type</th><th>Format</th><th>View</th><th>Download</th>";
while ($result = mysql_fetch_array($SQLsearch)){ 
  echo "<tr><td>".$result['filename']."</td><td align=right>".$result['blocks']."</td><td>".$result['filetype']."</td><td align='right'>".$result['fileformat']."</td><td align='center'><a target='_BLANK' href='view_directory.php?hyper_media_id=".$result['hyper_media_id']."'>dir</a></td><td align='center'><a href='release.php?download_hyper_media=".$result['hyper_media_id']."'>Get</td></tr>";
}
echo "</table>";
echo "</fieldset>";

echo "</fieldset>";


# File Entry dependencies (relations --> that isPartOf the release )
$SQLsearch = $DB->get_dependencies($release_id, true);
echo "<fieldset style='width:600px;'><legend><b>Relations</b></legend>";
echo "<input type='text' size='40' name='dep_md5'><input type='submit' name='add_dep' value='add md5'><p>";
echo "<fieldset style='width:570px;'><legend><b>Is Part Of (working)</b></legend>";
echo "<table><th>md5</th><th>Blocks</th><th>Comment</th><th>Status</th><th>Error</th><th>Edit</th><th>remove</th>";
while ($result = mysql_fetch_array($SQLsearch)){ 
  echo "<tr>
  <td style='font-size:10px;'>".$result['md5']."</td>
  <td align='right'>".ceil($result['bytes']/254)."</td>
  <td>".$result['comment']."</td>
  <td>".$result['status']."</td>
  <td>".$result['error_bits']."</td>
  <td><a target='_BLANK' href=release.php?data_md5=".$result['md5'].">edit</a></td>
  <td><input type='checkbox' name=Lrm_dep_id[] value=".$result['md5']."><input type='submit' name='rm_dep' value='remove'></td>
  </tr>";
}
echo "</table>";
echo "</fieldset><br>";
# File Alternatives
$SQLsearch = $DB->get_dependencies($release_id, false);
echo "<fieldset style='width:570px;'><legend><b>Is Part Of (unknown)</b></legend>";
echo "<table><th>md5</th><th>Blocks</th><th>Comment</th><th>Status</th><th>Error</th><th>Edit</th><th>remove</th>";
while ($result = mysql_fetch_array($SQLsearch)){ 
  echo "<tr>
  <td style='font-size:10px;'>".$result['md5']."</td>
  <td align=right>".ceil($result['bytes']/254)."</td>
  <td>".$result['comment']."</td>
  <td>".$result['status']."</td>
  <td>".$result['error_bits']."</td>
  <td><a target='_BLANK' href=release.php?data_md5=".$result['md5'].">edit</a></td>
  <td><input type='checkbox' name=Lrm_dep_id[] value=".$result['md5']."><input type='submit' name='rm_dep' value='remove'></td>
  </tr>";
}
echo "</table>";
echo "</fieldset>";
echo "</fieldset>";

echo "</form>";
echo "</fieldset>";
for($i=0;$i<20;$i++){echo "<br>";} 

?>
</body>
</html>